'use strict';Object.defineProperty(exports, "__esModule", { value: true });exports.registerHandlerValidations = exports.defineStepValidations = exports.defineHookValidations = undefined;var _lodash = require('lodash');var _lodash2 = _interopRequireDefault(_lodash);
var _hook_definition = require('../models/hook_definition');var _hook_definition2 = _interopRequireDefault(_hook_definition);
var _stacktraceJs = require('stacktrace-js');var _stacktraceJs2 = _interopRequireDefault(_stacktraceJs);
var _step_definition = require('../models/step_definition');var _step_definition2 = _interopRequireDefault(_step_definition);
var _validateArguments = require('validate-arguments');var _validateArguments2 = _interopRequireDefault(_validateArguments);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

var optionsValidation = {
  expectedType: 'function or object',
  predicate: function predicate(_ref) {var options = _ref.options;return !_lodash2.default.isPlainObject(options);} };


var optionsTimeoutValidation = {
  identifier: '"options.timeout"',
  expectedType: 'integer',
  predicate: function predicate(_ref2) {var options = _ref2.options;return options.timeout && !_lodash2.default.isInteger(options.timeout);} };


var fnValidation = {
  expectedType: 'function',
  predicate: function predicate(_ref3) {var code = _ref3.code;return !_lodash2.default.isFunction(code);} };


var defineHookValidations = exports.defineHookValidations = [
_lodash2.default.assign({ identifier: 'first argument' }, optionsValidation),
{
  identifier: '"options.tags"',
  expectedType: 'string',
  predicate: function predicate(_ref4) {var options = _ref4.options;return options.tags && !_lodash2.default.isString(options.tags);} },

optionsTimeoutValidation,
_lodash2.default.assign({ identifier: 'second argument' }, fnValidation)];


var defineStepValidations = exports.defineStepValidations = [
{
  identifier: 'first argument',
  expectedType: 'string or regular expression',
  predicate: function predicate(_ref5) {var pattern = _ref5.pattern;return !_lodash2.default.isRegExp(pattern) && !_lodash2.default.isString(pattern);} },

_lodash2.default.assign({ identifier: 'second argument' }, optionsValidation),
optionsTimeoutValidation,
_lodash2.default.assign({ identifier: 'third argument' }, fnValidation)];


var registerHandlerValidations = exports.registerHandlerValidations = [
{
  identifier: 'first argument',
  expectedType: 'string',
  predicate: function predicate(_ref6) {var eventName = _ref6.eventName;return !_lodash2.default.isString(eventName);} },

_lodash2.default.assign({ identifier: 'second argument' }, optionsValidation),
optionsTimeoutValidation,
_lodash2.default.assign({ identifier: 'third argument' }, fnValidation)];